#!\Perl\bin\perl.exe
#
# Filename: BookDetail.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "BookDetail.cgi";
my $sTemplateFileName = "BookDetail.html";



CheckSecurity(1);


my $sDetailErr;
my $sOrderErr;
my $sRatingErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "Detail" ) {
    DetailAction( $sAction ) }
  if ( $sForm eq "Order" ) {
    OrderAction( $sAction ) }
  if ( $sForm eq "Rating" ) {
    RatingAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
Detail_Show();
Order_Show();
Rating_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub DetailAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "ShoppingCart.cgi";
  
  $sParams = "?";
  $sParams = $sParams . "item_id=" . ToURL(GetParam("Trn_item_id"));
  # Load all form fields into variables


# Create SQL statement

  if ( length($sDetailErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sDetailErr = ProceedError();
  if ( length( $sDetailErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName . $sParams );
  
}


sub Detail_Show {
  my $pitem_id;

  my $pitem_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $flditem_id;
  my $fldname;
  my $fldauthor;
  my $fldcategory_id;
  my $fldprice;
  my $fldimage_url;
  my $fldnotes;
  my $fldproduct_url;
  my $flditem_id;
  my $pitem_id;

  my $sOrder;

  if ( $sDetailErr eq "" ) {
    # Load primary key and form parameters
    $flditem_id = GetParam("item_id");
    $oTpl->SetVar( "Trn_item_id", GetParam("item_id") );
    $pitem_id = GetParam("item_id");
    $oTpl->SetVar( "DetailError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $flditem_id = GetParam("item_id");
    $oTpl->SetVar( "Trn_item_id", GetParam("Trn_item_id") );
    $pitem_id = GetParam("PK_item_id");
    $oTpl->SetVar( "sDetailErr", $sDetailErr );
    $oTpl->Parse( "DetailError", "False" );
  }

  
  if ( ($pitem_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "item_id=" . ToSQL($pitem_id, "Number");
  $oTpl->SetVar( "PK_item_id", $pitem_id );

  my $sSQL = "select * from items where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "Detail") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $flditem_id = GetValue($ref_db_record, "item_id");
    $fldname = GetValue($ref_db_record, "name");
    $fldauthor = GetValue($ref_db_record, "author");
    $fldcategory_id = GetValue($ref_db_record, "category_id");
    $fldprice = GetValue($ref_db_record, "price");
    $fldimage_url = GetValue($ref_db_record, "image_url");
    $fldnotes = GetValue($ref_db_record, "notes");
    $fldproduct_url = GetValue($ref_db_record, "product_url");
    $oTpl->SetVar( "DetailDelete", "" );
    $oTpl->SetVar( "DetailUpdate", "" );
    $oTpl->SetVar( "DetailInsert", "" );
  } else {
    if ( $sDetailErr eq "" ) {
      $flditem_id = ToHTML(GetParam("item_id"));
    }
    $oTpl->SetVar( "DetailEdit", "" );
    $oTpl->SetVar( "DetailInsert", "" );
  }
  $oTpl->SetVar( "DetailCancel", "" );
  $fldcategory_id = DLookUp("categories", "name", "category_id=" . ToSQL($fldcategory_id, "Number"));
  # Set lookup fields
  if ( $sDetailErr eq "" ) {
  
$fldimage_url="<img border=0 src=" . $fldimage_url . ">";
$fldproduct_url="Review this book on Amazon.com";
  }
  # Show form field
  
      $oTpl->SetVar( "item_id", ToHTML($flditem_id));
      $oTpl->SetVar( "name", ToHTML($fldname));
      $oTpl->SetVar( "author", ToHTML($fldauthor));
      $oTpl->SetVar( "category_id", ToHTML($fldcategory_id));
      $oTpl->SetVar( "price", ToHTML($fldprice));
      $oTpl->SetVar( "image_url", $fldimage_url);
      $oTpl->SetVar( "image_url_URLLink", GetValue($ref_db_record, "product_url"));
      $oTpl->SetVar( "notes", $fldnotes);
      $oTpl->SetVar( "product_url", ToHTML($fldproduct_url) );
      $oTpl->SetVar( "product_url_URLLink", GetValue($ref_db_record, "product_url"));
  $oTpl->Parse( "FormDetail", "False" );
  

}



sub OrderAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "ShoppingCart.cgi";
  
  # Load all form fields into variables

  my $fldUserID = GetSessionVar("UserID");
  my $fldquantity = GetParam("quantity");
  my $flditem_id = GetParam("item_id");
  # Validate fields
  if ( $sAction eq "insert" or $sAction eq "update" ) {
    if ( $fldquantity eq "" ) {
      $sOrderErr = $sOrderErr . "The value in field Quantity is required.<br>"
    }
    if ( !IsNumeric($fldquantity) ) {
      $sOrderErr = $sOrderErr . "The value in field Quantity is incorrect.<br>"
    }
    if ( !IsNumeric($flditem_id) ) {
      $sOrderErr = $sOrderErr . "The value in field item_id is incorrect.<br>"
    }
    if ( length($sOrderErr) > 0 ) {
      return 0;
    }
  }


# Create SQL statement

    if ( $sAction eq "insert" ) {      
      
      $sSQL = "insert into orders (" . 
          "member_id," . 
          "quantity," . 
          "item_id)" . 
          " values (" . 
          ToSQL($fldUserID, "Number") . "," . 
          ToSQL($fldquantity, "Number") . "," . 
          ToSQL($flditem_id, "Number") . ")"
}
      
  if ( length($sOrderErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sOrderErr = ProceedError();
  if ( length( $sOrderErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName);
  
}


sub Order_Show {
  my $porder_id;

  my $porder_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $fldorder_id;
  my $fldquantity;
  my $flditem_id;
  my $flditem_id;
  my $fldUserID;
  my $porder_id;

  my $sOrder;

  if ( $sOrderErr eq "" ) {
    # Load primary key and form parameters
    $flditem_id = GetParam("item_id");
    $porder_id = GetParam("order_id");
    $oTpl->SetVar( "OrderError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $fldorder_id = GetParam("order_id");
    $fldquantity = GetParam("quantity");
    $flditem_id = GetParam("item_id");
    $porder_id = GetParam("PK_order_id");
    $oTpl->SetVar( "sOrderErr", $sOrderErr );
    $oTpl->Parse( "OrderError", "False" );
  }

  
  if ( ($porder_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "order_id=" . ToSQL($porder_id, "Number");
  $oTpl->SetVar( "PK_order_id", $porder_id );

  my $sSQL = "select * from orders where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "Order") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $fldorder_id = GetValue($ref_db_record, "order_id");
    $flditem_id = GetValue($ref_db_record, "item_id");
    if ( $sOrderErr eq "" ) {
      # Load data from recordset when form displayed first time
      $fldquantity = GetValue($ref_db_record, "quantity");
    }
    $oTpl->SetVar( "OrderDelete", "" );
    $oTpl->SetVar( "OrderUpdate", "" );
    $oTpl->SetVar( "OrderInsert", "" );
  } else {
    if ( $sOrderErr eq "" ) {
      $flditem_id = ToHTML(GetParam("item_id"));
      $fldquantity= "1";
    }
    $oTpl->SetVar( "OrderEdit", "" );
    $oTpl->Parse( "OrderInsert", "False" );
  }
  $oTpl->SetVar( "OrderCancel", "" );
  # Show form field
  
      $oTpl->SetVar( "order_id", ToHTML($fldorder_id));
      $oTpl->SetVar( "quantity", ToHTML($fldquantity));
      $oTpl->SetVar( "item_id", ToHTML($flditem_id));
  $oTpl->Parse( "FormOrder", "False" );
  

}



sub RatingAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "BookDetail.cgi";
  
  $sParams = "?";
  $sParams = $sParams . "item_id=" . ToURL(GetParam("Trn_item_id"));
  # Create WHERE statement
  if ( $sAction eq "update" or $sAction eq "delete" ) {
    my $pPKitem_id = GetParam("PK_item_id");
    if ( ($pPKitem_id eq "")) { return 0; }
    $sWhere = "item_id=" . ToSQL($pPKitem_id, "Number");
  }

  # Load all form fields into variables

  my $fldrating = GetParam("rating");
  my $fldrating_count = GetParam("rating_count");
  # Validate fields
  if ( $sAction eq "insert" or $sAction eq "update" ) {
    if ( $fldrating eq "" ) {
      $sRatingErr = $sRatingErr . "The value in field Your Rating is required.<br>"
    }
    if ( !IsNumeric($fldrating) ) {
      $sRatingErr = $sRatingErr . "The value in field Your Rating is incorrect.<br>"
    }
    if ( !IsNumeric($fldrating_count) ) {
      $sRatingErr = $sRatingErr . "The value in field rating_count is incorrect.<br>"
    }
    if ( length($sRatingErr) > 0 ) {
      return 0;
    }
  }


# Create SQL statement

    if ( $sAction eq "update" ) {
$sSQL = "update items set rating=rating+" . GetParam("rating") . ", rating_count=rating_count+1 where item_id=" . GetParam("item_id");
      if ( $sSQL eq "" ) {
        $sSQL = "update items set " .
        "rating=" . ToSQL($fldrating, "Number") .
        ",rating_count=" . ToSQL($fldrating_count, "Number");
        $sSQL = $sSQL . " where " . $sWhere
      }
    }
    
  if ( length($sRatingErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sRatingErr = ProceedError();
  if ( length( $sRatingErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName . $sParams );
  
}


sub Rating_Show {
  my $pitem_id;

  my $pitem_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $flditem_id;
  my $fldrating_view;
  my $fldrating_count_view;
  my $fldrating;
  my $fldrating_count;
  my $flditem_id;
  my $pitem_id;

  my $sOrder;

  if ( $sRatingErr eq "" ) {
    # Load primary key and form parameters
    $flditem_id = GetParam("item_id");
    $oTpl->SetVar( "Trn_item_id", GetParam("item_id") );
    $pitem_id = GetParam("item_id");
    $oTpl->SetVar( "RatingError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $flditem_id = GetParam("item_id");
    $fldrating = GetParam("rating");
    $fldrating_count = GetParam("rating_count");
    $oTpl->SetVar( "Trn_item_id", GetParam("Trn_item_id") );
    $pitem_id = GetParam("PK_item_id");
    $oTpl->SetVar( "sRatingErr", $sRatingErr );
    $oTpl->Parse( "RatingError", "False" );
  }

  
  if ( ($pitem_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "item_id=" . ToSQL($pitem_id, "Number");
  $oTpl->SetVar( "PK_item_id", $pitem_id );

  my $sSQL = "select * from items where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "Rating") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $flditem_id = GetValue($ref_db_record, "item_id");
    $fldrating_view = GetValue($ref_db_record, "rating");
    $fldrating_count_view = GetValue($ref_db_record, "rating_count");
    $fldrating_count = GetValue($ref_db_record, "rating_count");
    if ( $sRatingErr eq "" ) {
      # Load data from recordset when form displayed first time
      $fldrating = GetValue($ref_db_record, "rating");
    }
    $oTpl->SetVar( "RatingDelete", "" );
    $oTpl->SetVar( "RatingInsert", "" );
    $oTpl->Parse( "RatingEdit", "False" );
  } else {
    if ( $sRatingErr eq "" ) {
      $flditem_id = ToHTML(GetParam("item_id"));
    }
    $oTpl->SetVar( "RatingEdit", "" );
    $oTpl->SetVar( "RatingInsert", "" );
  }
  $oTpl->SetVar( "RatingCancel", "" );
  if ( $sRatingErr eq "" ) {
  
if ($fldrating_view == 0)
      {
        $fldrating_view = "Not rated yet";
        $fldrating_count_view = "";
      }
      else
      {
        $fldrating_view = "<img src=\"images/" . sprintf("%.0f", $fldrating/$fldrating_count) . "stars.gif\">";
      }
  }
  # Show form field
  
      $oTpl->SetVar( "item_id", ToHTML($flditem_id));
      $oTpl->SetVar( "rating_view", $fldrating_view);
      $oTpl->SetVar( "rating_count_view", ToHTML($fldrating_count_view));
      $oTpl->SetVar( "LBrating", "" );
      my @LOV = split( /;/, "1;Deficient;2;Regular;3;Good;4;Very Good;5;Excellent");
      if ( ($#LOV % 2) == 1 ) {
        for ( my $i = 0; $i <= $#LOV; $i+=2 ) {
          $oTpl->SetVar( "ID", $LOV[$i] );
	  $oTpl->SetVar( "Value", $LOV[$i+1] );
          if ( $LOV[$i] eq $fldrating ) { 
	    $oTpl->SetVar( "Selected", "SELECTED" ) 
	  } else { 
	    $oTpl->SetVar( "Selected", "" )
	  }
          $oTpl->Parse( "LBrating", "True" );
        }
      }
  
      $oTpl->SetVar( "rating_count", ToHTML($fldrating_count));
  $oTpl->Parse( "FormRating", "False" );
  

}