#!\Perl\bin\perl.exe
#
# Filename: CardTypesGrid.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "CardTypesGrid.cgi";
my $sTemplateFileName = "CardTypesGrid.html";



CheckSecurity(2);


$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



#Show form content

Menu_Show();
Footer_Show();
CardTypes_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub CardTypes_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );
# Build WHERE statement

  # Build ORDER statement
  $sOrder = " order by c.name Asc";
  $iSort = GetParam("FormCardTypes_Sorting");
  $iSorted = GetParam("FormCardTypes_Sorted");
  $sDirection = "";
  if ( $iSort eq "" ) {
    $oTpl->SetVar( "Form_Sorting", "" );
  } else {
    if ( $iSort eq $iSorted ) { 
      $oTpl->SetVar( "Form_Sorting", "" );
      $sDirection = " DESC";
      $sSortParams = "FormCardTypes_Sorting=" . $iSort . "&FormCardTypes_Sorted=" . $iSort . "&";
    } else {
      $oTpl->SetVar( "Form_Sorting", $iSort );
      $sDirection = " ASC";
      $sSortParams = "FormCardTypes_Sorting=" . $iSort . "&FormCardTypes_Sorted=" . "&"
    }
    
    if ( $iSort == 1) { $sOrder = " order by c.name" . $sDirection }
  }

  # Build full SQL statement
  
  my $sSQL = "select c.card_type_id as c_card_type_id, " . "c.name as c_name " . " from card_types c ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  $oTpl->SetVar( "FormAction", "CardTypesRecord.cgi" );
  $oTpl->SetVar( "SortParams", $sSortParams );
  
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListCardTypes", "" );
    $oTpl->Parse( "CardTypesNoRecords", "False" );
    $oTpl->Parse( "FormCardTypes", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldname = GetValue($ref_db_record, "c_name");

      $oTpl->SetVar( "name", ToHTML($fldname) );
      $oTpl->SetVar( "name_URLLink", "CardTypesRecord.cgi");
      $oTpl->SetVar( "Prm_card_type_id", ToURL(GetValue($ref_db_record, "c_card_type_id"))); 

    $oTpl->Parse( "DListCardTypes", "True" );
    
  }


  $oTpl->SetVar( "CardTypesNoRecords", "" );
  $oTpl->Parse( "FormCardTypes", "False" );
  
}