#!\Perl\bin\perl.exe
#
# Filename: EditorialCatGrid.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "EditorialCatGrid.cgi";
my $sTemplateFileName = "EditorialCatGrid.html";



CheckSecurity(2);


$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



#Show form content

Menu_Show();
Footer_Show();
editorial_categories_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub editorial_categories_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );
# Build WHERE statement

  # Build ORDER statement
  $sOrder = " order by e.editorial_cat_name Asc";
  $iSort = GetParam("Formeditorial_categories_Sorting");
  $iSorted = GetParam("Formeditorial_categories_Sorted");
  $sDirection = "";
  if ( $iSort eq "" ) {
    $oTpl->SetVar( "Form_Sorting", "" );
  } else {
    if ( $iSort eq $iSorted ) { 
      $oTpl->SetVar( "Form_Sorting", "" );
      $sDirection = " DESC";
      $sSortParams = "Formeditorial_categories_Sorting=" . $iSort . "&Formeditorial_categories_Sorted=" . $iSort . "&";
    } else {
      $oTpl->SetVar( "Form_Sorting", $iSort );
      $sDirection = " ASC";
      $sSortParams = "Formeditorial_categories_Sorting=" . $iSort . "&Formeditorial_categories_Sorted=" . "&"
    }
    
    if ( $iSort == 1) { $sOrder = " order by e.editorial_cat_name" . $sDirection }
  }

  # Build full SQL statement
  
  my $sSQL = "select e.editorial_cat_id as e_editorial_cat_id, " . "e.editorial_cat_name as e_editorial_cat_name " . " from editorial_categories e ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  $oTpl->SetVar( "FormAction", "EditorialCatRecord.cgi" );
  $oTpl->SetVar( "SortParams", $sSortParams );
  
  # Select current page
  $iPage = GetParam("Formeditorial_categories_Page");
  if ( $iPage eq "" ) { $iPage = 1 }
  $RecordsPerPage = 20;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListeditorial_categories", "" );
    $oTpl->Parse( "editorial_categoriesNoRecords", "False" );
    $oTpl->SetVar( "editorial_categoriesScroller", "" );
    $oTpl->Parse( "Formeditorial_categories", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldeditorial_cat_id = GetValue($ref_db_record, "e_editorial_cat_id");
    my $fldeditorial_cat_name = GetValue($ref_db_record, "e_editorial_cat_name");

      $oTpl->SetVar( "editorial_cat_id", ToHTML($fldeditorial_cat_id));
      $oTpl->SetVar( "editorial_cat_name", ToHTML($fldeditorial_cat_name) );
      $oTpl->SetVar( "editorial_cat_name_URLLink", "EditorialCatRecord.cgi");
      $oTpl->SetVar( "Prm_editorial_cat_id", ToURL(GetValue($ref_db_record, "e_editorial_cat_id"))); 

    $oTpl->Parse( "DListeditorial_categories", "True" );
    
  }


  # Parse scroller
  if ( $is_last_page and $iPage == 1 ) {
    $oTpl->SetVar( "editorial_categoriesScroller", "" );
  } else {
    if ( $is_last_page ) {
      $oTpl->SetVar( "editorial_categoriesScrollerNextSwitch", "_" );
    } else {
      $oTpl->SetVar( "NextPage", ($iPage + 1) );
      $oTpl->SetVar( "editorial_categoriesScrollerNextSwitch", "" );
    }
    if ( $iPage == 1 ) {
      $oTpl->SetVar( "editorial_categoriesScrollerPrevSwitch", "_" );
    } else {
      $oTpl->SetVar( "PrevPage", ($iPage - 1) );
      $oTpl->SetVar( "editorial_categoriesScrollerPrevSwitch", "" );
    }
    $oTpl->SetVar( "editorial_categoriesCurrentPage", $iPage );
    $oTpl->Parse( "editorial_categoriesScroller", "False" );
  }

  $oTpl->SetVar( "editorial_categoriesNoRecords", "" );
  $oTpl->Parse( "Formeditorial_categories", "False" );
  
}