#!\Perl\bin\perl.exe
#
# Filename: EditorialCatRecord.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "EditorialCatRecord.cgi";
my $sTemplateFileName = "EditorialCatRecord.html";



CheckSecurity(2);


my $seditorial_categoriesErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "editorial_categories" ) {
    editorial_categoriesAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
editorial_categories_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub editorial_categoriesAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "EditorialCatGrid.cgi";
  
  if ( $sAction eq "cancel" ) { http_redirect( $sActionFileName ) }
  # Create WHERE statement
  if ( $sAction eq "update" or $sAction eq "delete" ) {
    my $pPKeditorial_cat_id = GetParam("PK_editorial_cat_id");
    if ( ($pPKeditorial_cat_id eq "")) { return 0; }
    $sWhere = "editorial_cat_id=" . ToSQL($pPKeditorial_cat_id, "Number");
  }

  # Load all form fields into variables

  my $fldeditorial_cat_name = GetParam("editorial_cat_name");
  # Validate fields
  if ( $sAction eq "insert" or $sAction eq "update" ) {
    if ( length($seditorial_categoriesErr) > 0 ) {
      return 0;
    }
  }


# Create SQL statement

    if ( $sAction eq "insert" ) {      
      
      $sSQL = "insert into editorial_categories (" . 
          "editorial_cat_name)" . 
          " values (" . 
          ToSQL($fldeditorial_cat_name, "Text") . ")"
}
      
    if ( $sAction eq "update" ) {
        $sSQL = "update editorial_categories set " .
        "editorial_cat_name=" . ToSQL($fldeditorial_cat_name, "Text");
        $sSQL = $sSQL . " where " . $sWhere
    }
    
    if ( $sAction eq "delete" ) {
        $sSQL = "delete from editorial_categories where " . $sWhere
    }
    
  if ( length($seditorial_categoriesErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $seditorial_categoriesErr = ProceedError();
  if ( length( $seditorial_categoriesErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName);
  
}


sub editorial_categories_Show {
  my $peditorial_cat_id;

  my $peditorial_cat_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $fldeditorial_cat_id;
  my $fldeditorial_cat_name;
  my $fldeditorial_cat_id;
  my $peditorial_cat_id;

  my $sOrder;

  if ( $seditorial_categoriesErr eq "" ) {
    # Load primary key and form parameters
    $fldeditorial_cat_id = GetParam("editorial_cat_id");
    $peditorial_cat_id = GetParam("editorial_cat_id");
    $oTpl->SetVar( "editorial_categoriesError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $fldeditorial_cat_id = GetParam("editorial_cat_id");
    $fldeditorial_cat_name = GetParam("editorial_cat_name");
    $peditorial_cat_id = GetParam("PK_editorial_cat_id");
    $oTpl->SetVar( "seditorial_categoriesErr", $seditorial_categoriesErr );
    $oTpl->Parse( "editorial_categoriesError", "False" );
  }

  
  if ( ($peditorial_cat_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "editorial_cat_id=" . ToSQL($peditorial_cat_id, "Number");
  $oTpl->SetVar( "PK_editorial_cat_id", $peditorial_cat_id );

  my $sSQL = "select * from editorial_categories where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "editorial_categories") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $fldeditorial_cat_id = GetValue($ref_db_record, "editorial_cat_id");
    if ( $seditorial_categoriesErr eq "" ) {
      # Load data from recordset when form displayed first time
      $fldeditorial_cat_name = GetValue($ref_db_record, "editorial_cat_name");
    }
    $oTpl->SetVar( "editorial_categoriesInsert", "" );
    $oTpl->Parse( "editorial_categoriesEdit", "False" );
  } else {
    if ( $seditorial_categoriesErr eq "" ) {
      $fldeditorial_cat_id = ToHTML(GetParam("editorial_cat_id"));
    }
    $oTpl->SetVar( "editorial_categoriesEdit", "" );
    $oTpl->Parse( "editorial_categoriesInsert", "False" );
  }
  $oTpl->Parse( "editorial_categoriesCancel", "False" );
  # Show form field
  
      $oTpl->SetVar( "editorial_cat_id", ToHTML($fldeditorial_cat_id));
      $oTpl->SetVar( "editorial_cat_name", ToHTML($fldeditorial_cat_name));
  $oTpl->Parse( "Formeditorial_categories", "False" );
  

}