#!\Perl\bin\perl.exe
#
# Filename: Login.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "Login.cgi";
my $sTemplateFileName = "Login.html";




my $sLoginErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "Login" ) {
    LoginAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
Login_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;



sub LoginAction {
  my $sAction = shift;
  my ( $sQueryString, $sPage );
  if ( $sAction eq "login" ) {
    # Login action
    
    my $sLogin = GetParam("Login");
    my $sPassword = GetParam("Password");
    my $bPassed = DLookUp("members", "count(*)", "member_login =" . ToSQL($sLogin, "Text") . " and member_password=" . ToSQL($sPassword, "Text"));
    
    if ( $bPassed ) {
    # Login and password passed
      SetSessionVar("UserID", DLookUp("members", "member_id", "member_login =" . ToSQL($sLogin, "Text") . " and member_password=" . ToSQL($sPassword, "Text")));

      SetSessionVar("UserRights", DLookUp("members", "member_level", "member_login =" . ToSQL($sLogin, "Text") . " and member_password=" . ToSQL($sPassword, "Text")));
      $sQueryString = GetParam("querystring");
      $sPage = GetParam("ret_page");
      if ($sPage ne "" ) {
        http_redirect( $sPage . "?" . $sQueryString );
      }
      
         http_redirect("ShoppingCart.cgi");
      } else {
        $oTpl->SetVar( "querystring", $sQueryString );
        $oTpl->SetVar( "ret_page", $sPage );
	$sLoginErr = "Login or Password is incorrect.";
      }
      $oTpl->Parse( "FormLogin", "False" );
   
   } 
   if ( $sAction eq "logout" ) {
     # Logout action
     
     SetSessionVar("UserID", "" );
     SetSessionVar("UserRights", "" );
     $oTpl->Parse( "FormLogin", "False" );
     
   }
}

sub Login_Show {
  
  $oTpl->SetVar( "sLoginErr", $sLoginErr );
  $oTpl->SetVar( "querystring", GetParam("querystring") );
  $oTpl->SetVar( "ret_page", GetParam("ret_page") );
  
  if ( GetSessionVar("UserID") eq "" ) {
    # User did not login
    $oTpl->SetVar( "LogoutAct", "" );
    $oTpl->SetVar( "UserInd", "" );
    $oTpl->SetVar( "Login", ToHTML(GetParam("Login")));
    if ( $sLoginErr eq "" ) {
      $oTpl->SetVar( "LoginError", "" );
    } else {
      $oTpl->SetVar( "sLoginErr", $sLoginErr );
      $oTpl->Parse( "LoginError", "False" );
    }
    $oTpl->Parse( "LoginAct", "False" );
  } else {
    # User logged in
    $oTpl->SetVar( "LoginError", "" );
    $oTpl->SetVar( "LoginAct", "" );
    $oTpl->SetVar( "UserID", DLookUp("members", "member_login", "member_id =" . GetSessionVar("UserID") ) ); 
    $oTpl->Parse( "UserInd", "False" );
  }
  $oTpl->Parse( "FormLogin", "False" );
  


}