#!\Perl\bin\perl.exe
#
# Filename: MembersInfo.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "MembersInfo.cgi";
my $sTemplateFileName = "MembersInfo.html";



CheckSecurity(2);


my $sRecordErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "Record" ) {
    RecordAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
Record_Show();
Orders_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub RecordAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "AdminMenu.cgi";
  
  # Load all form fields into variables


# Create SQL statement

  if ( length($sRecordErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sRecordErr = ProceedError();
  if ( length( $sRecordErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName);
  
}


sub Record_Show {
  my $pmember_id;

  my $pmember_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $fldmember_id;
  my $fldmember_login;
  my $fldmember_level;
  my $fldname;
  my $fldlast_name;
  my $fldemail;
  my $fldphone;
  my $fldaddress;
  my $fldnotes;
  my $pmember_id;

  my $sOrder;

  if ( $sRecordErr eq "" ) {
    # Load primary key and form parameters
    $pmember_id = GetParam("member_id");
    $oTpl->SetVar( "RecordError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $fldmember_id = GetParam("member_id");
    $pmember_id = GetParam("PK_member_id");
    $oTpl->SetVar( "sRecordErr", $sRecordErr );
    $oTpl->Parse( "RecordError", "False" );
  }

  
  if ( ($pmember_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "member_id=" . ToSQL($pmember_id, "Number");
  $oTpl->SetVar( "PK_member_id", $pmember_id );

  my $sSQL = "select * from members where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "Record") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $fldmember_id = GetValue($ref_db_record, "member_id");
    $fldmember_login = GetValue($ref_db_record, "member_login");
    $fldmember_level = GetValue($ref_db_record, "member_level");
    $fldname = GetValue($ref_db_record, "first_name");
    $fldlast_name = GetValue($ref_db_record, "last_name");
    $fldemail = GetValue($ref_db_record, "email");
    $fldphone = GetValue($ref_db_record, "phone");
    $fldaddress = GetValue($ref_db_record, "address");
    $fldnotes = GetValue($ref_db_record, "notes");
    $oTpl->SetVar( "RecordDelete", "" );
    $oTpl->SetVar( "RecordUpdate", "" );
    $oTpl->SetVar( "RecordInsert", "" );
  } else {
    $oTpl->SetVar( "RecordEdit", "" );
    $oTpl->SetVar( "RecordInsert", "" );
  }
  $oTpl->SetVar( "RecordCancel", "" );
  # Show form field
  
      $oTpl->SetVar( "member_id", ToHTML($fldmember_id));
      $oTpl->SetVar( "member_login", ToHTML($fldmember_login) );
      $oTpl->SetVar( "member_login_URLLink", "MembersRecord.cgi");
      $oTpl->SetVar( "Prm_member_id", ToURL(GetValue($ref_db_record, "member_id"))); 
      $oTpl->SetVar( "member_level", ToHTML($fldmember_level));
      $oTpl->SetVar( "name", ToHTML($fldname));
      $oTpl->SetVar( "last_name", ToHTML($fldlast_name));
      $oTpl->SetVar( "email", ToHTML($fldemail));
      $oTpl->SetVar( "phone", ToHTML($fldphone));
      $oTpl->SetVar( "address", ToHTML($fldaddress));
      $oTpl->SetVar( "notes", ToHTML($fldnotes));
  $oTpl->Parse( "FormRecord", "False" );
  

}



sub Orders_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "member_id=" . ToURL(GetParam("member_id")) . "&" );
  $oTpl->SetVar( "FormParams", "member_id=" . ToURL(GetParam("member_id")) . "&");  
  my $bReq = "1";
# Build WHERE statement

# Check member_id parameter and create a valid sql for where clause
  
  my $pmember_id = GetParam("member_id");
  if ( $pmember_id ne "" ) { $pmember_id = int($pmember_id) } else { $pmember_id = "" }
  if ( $pmember_id ne "" ) {
	$HasParam = 1;
    $sWhere = $sWhere . "o.member_id=" . $pmember_id
  } else {
    $bReq = ""
  }
  
  if ( $HasParam ) { $sWhere = " AND (" . $sWhere . ")" }
  # Build ORDER statement
  $iSort = GetParam("FormOrders_Sorting");
  $iSorted = GetParam("FormOrders_Sorted");
  $sDirection = "";
  if ( $iSort eq "" ) {
    $oTpl->SetVar( "Form_Sorting", "" );
  } else {
    if ( $iSort eq $iSorted ) { 
      $oTpl->SetVar( "Form_Sorting", "" );
      $sDirection = " DESC";
      $sSortParams = "FormOrders_Sorting=" . $iSort . "&FormOrders_Sorted=" . $iSort . "&";
    } else {
      $oTpl->SetVar( "Form_Sorting", $iSort );
      $sDirection = " ASC";
      $sSortParams = "FormOrders_Sorting=" . $iSort . "&FormOrders_Sorted=" . "&"
    }
    
    if ( $iSort == 1) { $sOrder = " order by o.order_id" . $sDirection }
    if ( $iSort == 2) { $sOrder = " order by i.name" . $sDirection }
    if ( $iSort == 3) { $sOrder = " order by o.quantity" . $sDirection }
  }

  # Build full SQL statement
  
  my $sSQL = "select o.item_id as o_item_id, " . "o.member_id as o_member_id, " . "o.order_id as o_order_id, " . "o.quantity as o_quantity, " . "i.item_id as i_item_id, " . "i.name as i_name " . " from orders o, items as i" . " where i.item_id=o.item_id  ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  $oTpl->SetVar( "SortParams", $sSortParams );
  
  if ( !$bReq ) {
    $oTpl->SetVar( "DListOrders", "" );
    $oTpl->Parse( "OrdersNoRecords", "False" );

    $oTpl->Parse( "FormOrders", "False" );
    return 0
  }

  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListOrders", "" );
    $oTpl->Parse( "OrdersNoRecords", "False" );
    $oTpl->Parse( "FormOrders", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldorder_id = GetValue($ref_db_record, "o_order_id");
    my $flditem_id = GetValue($ref_db_record, "i_name");
    my $fldquantity = GetValue($ref_db_record, "o_quantity");

      $oTpl->SetVar( "order_id", ToHTML($fldorder_id) );
      $oTpl->SetVar( "order_id_URLLink", "OrdersRecord.cgi");
      $oTpl->SetVar( "Prm_order_id", ToURL(GetValue($ref_db_record, "o_order_id"))); 
      $oTpl->SetVar( "item_id", ToHTML($flditem_id));
      $oTpl->SetVar( "quantity", ToHTML($fldquantity));

    $oTpl->Parse( "DListOrders", "True" );
    
  }


  $oTpl->SetVar( "OrdersNoRecords", "" );
  $oTpl->Parse( "FormOrders", "False" );
  
}