#!\Perl\bin\perl.exe
#
# Filename: OrdersGrid.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "OrdersGrid.cgi";
my $sTemplateFileName = "OrdersGrid.html";



CheckSecurity(2);


$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



#Show form content

Menu_Show();
Footer_Show();
Search_Show();
Orders_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub Search_Show {
  
  $oTpl->SetVar( "ActionPage", "OrdersGrid.cgi" );

  # Set variables with search parameters
  
  my $flditem_id = GetParam("item_id");
  my $fldmember_id = GetParam("member_id");
  # Show fields
  

      $oTpl->SetVar( "LBitem_id", "" );
      $oTpl->SetVar( "ID", "" );
      $oTpl->SetVar( "Value", "All" );
      $oTpl->Parse( "LBitem_id", "True" );
      my @item_id = openrs_arr( "select item_id, name from items order by 2" );
      foreach my $item_id ( @item_id ) {
        $oTpl->SetVar( "ID", $item_id->[0] );
	$oTpl->SetVar( "Value", $item_id->[1] );
        if ( GetValue($item_id, 0) eq $flditem_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBitem_id", "True" );
      }
        
      $oTpl->SetVar( "LBmember_id", "" );
      $oTpl->SetVar( "ID", "" );
      $oTpl->SetVar( "Value", "All" );
      $oTpl->Parse( "LBmember_id", "True" );
      my @member_id = openrs_arr( "select member_id, member_login from members order by 2" );
      foreach my $member_id ( @member_id ) {
        $oTpl->SetVar( "ID", $member_id->[0] );
	$oTpl->SetVar( "Value", $member_id->[1] );
        if ( GetValue($member_id, 0) eq $fldmember_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBmember_id", "True" );
      }
        
  $oTpl->Parse( "FormSearch", "False" );
}



sub Orders_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "item_id=" . ToURL(GetParam("item_id")) . "&member_id=" . ToURL(GetParam("member_id")) . "&" );
  $oTpl->SetVar( "FormParams", "item_id=" . ToURL(GetParam("item_id")) . "&member_id=" . ToURL(GetParam("member_id")) . "&");
# Build WHERE statement

# Check item_id parameter and create a valid sql for where clause
  
  my $pitem_id = GetParam("item_id");
  if ( $pitem_id ne "" ) { $pitem_id = int($pitem_id) } else { $pitem_id = "" }
  if ( $pitem_id ne "" ) {
	$HasParam = 1;
    $sWhere = $sWhere . "o.item_id=" . $pitem_id
  }
  
# Check member_id parameter and create a valid sql for where clause
  
  my $pmember_id = GetParam("member_id");
  if ( $pmember_id ne "" ) { $pmember_id = int($pmember_id) } else { $pmember_id = "" }
  if ( $pmember_id ne "" ) {
    if ( $sWhere ne "" ) { $sWhere = $sWhere . " and " }
	$HasParam = 1;
    $sWhere = $sWhere . "o.member_id=" . $pmember_id
  }
  
  if ( $HasParam ) { $sWhere = " AND (" . $sWhere . ")" }
  # Build ORDER statement
  $sOrder = " order by o.order_id Asc";
  $iSort = GetParam("FormOrders_Sorting");
  $iSorted = GetParam("FormOrders_Sorted");
  $sDirection = "";
  if ( $iSort eq "" ) {
    $oTpl->SetVar( "Form_Sorting", "" );
  } else {
    if ( $iSort eq $iSorted ) { 
      $oTpl->SetVar( "Form_Sorting", "" );
      $sDirection = " DESC";
      $sSortParams = "FormOrders_Sorting=" . $iSort . "&FormOrders_Sorted=" . $iSort . "&";
    } else {
      $oTpl->SetVar( "Form_Sorting", $iSort );
      $sDirection = " ASC";
      $sSortParams = "FormOrders_Sorting=" . $iSort . "&FormOrders_Sorted=" . "&"
    }
    
    if ( $iSort == 1) { $sOrder = " order by i.name" . $sDirection }
    if ( $iSort == 2) { $sOrder = " order by m.member_login" . $sDirection }
    if ( $iSort == 3) { $sOrder = " order by o.quantity" . $sDirection }
  }

  # Build full SQL statement
  
  my $sSQL = "select o.item_id as o_item_id, " . "o.member_id as o_member_id, " . "o.order_id as o_order_id, " . "o.quantity as o_quantity, " . "i.item_id as i_item_id, " . "i.name as i_name, " . "m.member_id as m_member_id, " . "m.member_login as m_member_login " . " from orders o, items as i, members as m" . " where i.item_id=o.item_id and m.member_id=o.member_id  ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  $oTpl->SetVar( "FormAction", "OrdersRecord.cgi" );
  $oTpl->SetVar( "SortParams", $sSortParams );
  
  # Select current page
  $iPage = GetParam("FormOrders_Page");
  if ( $iPage eq "" ) { $iPage = 1 }
  $RecordsPerPage = 20;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListOrders", "" );
    $oTpl->Parse( "OrdersNoRecords", "False" );
    $oTpl->SetVar( "OrdersScroller", "" );
    $oTpl->Parse( "FormOrders", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldorder_id = GetValue($ref_db_record, "o_order_id");
    my $flditem_id = GetValue($ref_db_record, "i_name");
    my $fldmember_id = GetValue($ref_db_record, "m_member_login");
    my $fldquantity = GetValue($ref_db_record, "o_quantity");
    my $fldField1= "Edit";

      $oTpl->SetVar( "Field1", ToHTML($fldField1) );
      $oTpl->SetVar( "Field1_URLLink", "OrdersRecord.cgi");
      $oTpl->SetVar( "Prm_order_id", ToURL(GetValue($ref_db_record, "o_order_id"))); 
      $oTpl->SetVar( "order_id", ToHTML($fldorder_id));
      $oTpl->SetVar( "item_id", ToHTML($flditem_id));
      $oTpl->SetVar( "member_id", ToHTML($fldmember_id));
      $oTpl->SetVar( "quantity", ToHTML($fldquantity));

    $oTpl->Parse( "DListOrders", "True" );
    
  }


  # Parse scroller
  if ( $is_last_page and $iPage == 1 ) {
    $oTpl->SetVar( "OrdersScroller", "" );
  } else {
    if ( $is_last_page ) {
      $oTpl->SetVar( "OrdersScrollerNextSwitch", "_" );
    } else {
      $oTpl->SetVar( "NextPage", ($iPage + 1) );
      $oTpl->SetVar( "OrdersScrollerNextSwitch", "" );
    }
    if ( $iPage == 1 ) {
      $oTpl->SetVar( "OrdersScrollerPrevSwitch", "_" );
    } else {
      $oTpl->SetVar( "PrevPage", ($iPage - 1) );
      $oTpl->SetVar( "OrdersScrollerPrevSwitch", "" );
    }
    $oTpl->SetVar( "OrdersCurrentPage", $iPage );
    $oTpl->Parse( "OrdersScroller", "False" );
  }

  $oTpl->SetVar( "OrdersNoRecords", "" );
  $oTpl->Parse( "FormOrders", "False" );
  
}