#!\Perl\bin\perl.exe
#
# Filename: Books.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "Books.cgi";
my $sTemplateFileName = "Books.html";




$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



#Show form content

Menu_Show();
Footer_Show();
Results_Show();
Search_Show();
AdvMenu_Show();
Total_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub Results_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "category_id=" . ToURL(GetParam("category_id")) . "&name=" . ToURL(GetParam("name")) . "&pricemin=" . ToURL(GetParam("pricemin")) . "&pricemax=" . ToURL(GetParam("pricemax")) . "&author=" . ToURL(GetParam("author")) . "&" );
  $oTpl->SetVar( "FormParams", "category_id=" . ToURL(GetParam("category_id")) . "&name=" . ToURL(GetParam("name")) . "&pricemin=" . ToURL(GetParam("pricemin")) . "&pricemax=" . ToURL(GetParam("pricemax")) . "&author=" . ToURL(GetParam("author")) . "&");
# Build WHERE statement

# Check author parameter and create a valid sql for where clause
  
  my $pauthor = GetParam("author");
  if ( $pauthor ne "" ) {
	$HasParam = 1;
    $sWhere = $sWhere . "i.author like '%" . replace($pauthor, "'", "''") . "%'"
  }
  
# Check category_id parameter and create a valid sql for where clause
  
  my $pcategory_id = GetParam("category_id");
  if ( $pcategory_id ne "" ) { $pcategory_id = int($pcategory_id) } else { $pcategory_id = "" }
  if ( $pcategory_id ne "" ) {
    if ( $sWhere ne "" ) { $sWhere = $sWhere . " and " }
	$HasParam = 1;
    $sWhere = $sWhere . "i.category_id=" . $pcategory_id
  }
  
# Check name parameter and create a valid sql for where clause
  
  my $pname = GetParam("name");
  if ( $pname ne "" ) {
    if ( $sWhere ne "" ) { $sWhere = $sWhere . " and " }
	$HasParam = 1;
    $sWhere = $sWhere . "i.name like '%" . replace($pname, "'", "''") . "%'"
  }
  
# Check pricemax parameter and create a valid sql for where clause
  
  my $ppricemax = GetParam("pricemax");
  if ( $ppricemax ne "" ) { $ppricemax = int($ppricemax) } else { $ppricemax = "" }
  if ( $ppricemax ne "" ) {
    if ( $sWhere ne "" ) { $sWhere = $sWhere . " and " }
	$HasParam = 1;
    $sWhere = $sWhere . "i.price<" . $ppricemax
  }
  
# Check pricemin parameter and create a valid sql for where clause
  
  my $ppricemin = GetParam("pricemin");
  if ( $ppricemin ne "" ) { $ppricemin = int($ppricemin) } else { $ppricemin = "" }
  if ( $ppricemin ne "" ) {
    if ( $sWhere ne "" ) { $sWhere = $sWhere . " and " }
	$HasParam = 1;
    $sWhere = $sWhere . "i.price>" . $ppricemin
  }
  
  if ( $HasParam ) { $sWhere = " AND (" . $sWhere . ")" }
  # Build ORDER statement
  $sOrder = " order by i.name Asc";
  $iSort = GetParam("FormResults_Sorting");
  $iSorted = GetParam("FormResults_Sorted");
  $sDirection = "";
  if ( $iSort eq "" ) {
    $oTpl->SetVar( "Form_Sorting", "" );
  } else {
    if ( $iSort eq $iSorted ) { 
      $oTpl->SetVar( "Form_Sorting", "" );
      $sDirection = " DESC";
      $sSortParams = "FormResults_Sorting=" . $iSort . "&FormResults_Sorted=" . $iSort . "&";
    } else {
      $oTpl->SetVar( "Form_Sorting", $iSort );
      $sDirection = " ASC";
      $sSortParams = "FormResults_Sorting=" . $iSort . "&FormResults_Sorted=" . "&"
    }
    
    if ( $iSort == 1) { $sOrder = " order by i.name" . $sDirection }
    if ( $iSort == 2) { $sOrder = " order by i.author" . $sDirection }
    if ( $iSort == 3) { $sOrder = " order by i.price" . $sDirection }
    if ( $iSort == 4) { $sOrder = " order by c.name" . $sDirection }
    if ( $iSort == 5) { $sOrder = " order by i.image_url" . $sDirection }
  }

  # Build full SQL statement
  
  my $sSQL = "select i.author as i_author, " . "i.category_id as i_category_id, " . "i.image_url as i_image_url, " . "i.item_id as i_item_id, " . "i.name as i_name, " . "i.price as i_price, " . "c.category_id as c_category_id, " . "c.name as c_name " . " from items i, categories as c" . " where c.category_id=i.category_id  ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  $oTpl->SetVar( "SortParams", $sSortParams );
  
  # Select current page
  $iPage = GetParam("FormResults_Page");
  if ( $iPage eq "" ) { $iPage = 1 }
  $RecordsPerPage = 20;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListResults", "" );
    $oTpl->Parse( "ResultsNoRecords", "False" );
    $oTpl->SetVar( "ResultsScroller", "" );
    $oTpl->Parse( "FormResults", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldname = GetValue($ref_db_record, "i_name");
    my $fldauthor = GetValue($ref_db_record, "i_author");
    my $fldprice = GetValue($ref_db_record, "i_price");
    my $fldcategory_id = GetValue($ref_db_record, "c_name");
    my $fldimage_url = GetValue($ref_db_record, "i_image_url");
$fldimage_url="<img border=0 src=" . $fldimage_url . ">";

      $oTpl->SetVar( "name", ToHTML($fldname) );
      $oTpl->SetVar( "name_URLLink", "BookDetail.cgi");
      $oTpl->SetVar( "Prm_item_id", ToURL(GetValue($ref_db_record, "i_item_id"))); 
      $oTpl->SetVar( "author", ToHTML($fldauthor));
      $oTpl->SetVar( "price", ToHTML($fldprice));
      $oTpl->SetVar( "category_id", ToHTML($fldcategory_id));
      $oTpl->SetVar( "image_url", $fldimage_url);
      $oTpl->SetVar( "image_url_URLLink", "BookDetail.cgi");
      $oTpl->SetVar( "Prm_item_id", ToURL(GetValue($ref_db_record, "i_item_id"))); 

    $oTpl->Parse( "DListResults", "True" );
    
  }


  # Parse scroller
  if ( $is_last_page and $iPage == 1 ) {
    $oTpl->SetVar( "ResultsScroller", "" );
  } else {
    if ( $is_last_page ) {
      $oTpl->SetVar( "ResultsScrollerNextSwitch", "_" );
    } else {
      $oTpl->SetVar( "NextPage", ($iPage + 1) );
      $oTpl->SetVar( "ResultsScrollerNextSwitch", "" );
    }
    if ( $iPage == 1 ) {
      $oTpl->SetVar( "ResultsScrollerPrevSwitch", "_" );
    } else {
      $oTpl->SetVar( "PrevPage", ($iPage - 1) );
      $oTpl->SetVar( "ResultsScrollerPrevSwitch", "" );
    }
    $oTpl->SetVar( "ResultsCurrentPage", $iPage );
    $oTpl->Parse( "ResultsScroller", "False" );
  }

  $oTpl->SetVar( "ResultsNoRecords", "" );
  $oTpl->Parse( "FormResults", "False" );
  
}



sub Search_Show {
  
  $oTpl->SetVar( "ActionPage", "Books.cgi" );

  # Set variables with search parameters
  
  my $fldcategory_id = GetParam("category_id");
  my $fldname = GetParam("name");
  # Show fields
  

      $oTpl->SetVar( "LBcategory_id", "" );
      $oTpl->SetVar( "ID", "" );
      $oTpl->SetVar( "Value", "All" );
      $oTpl->Parse( "LBcategory_id", "True" );
      my @category_id = openrs_arr( "select category_id, name from categories order by 2" );
      foreach my $category_id ( @category_id ) {
        $oTpl->SetVar( "ID", $category_id->[0] );
	$oTpl->SetVar( "Value", $category_id->[1] );
        if ( GetValue($category_id, 0) eq $fldcategory_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBcategory_id", "True" );
      }
        
      $oTpl->SetVar( "name", ToHTML($fldname));
  $oTpl->Parse( "FormSearch", "False" );
}


sub AdvMenu_Show {
  
  # Set URLs

  my $fldField1 = "AdvSearch.cgi";
  # Show fields

  $oTpl->SetVar( "Field1", $fldField1);  
  $oTpl->Parse( "FormAdvMenu", "False" );
  
}



sub Total_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );
  $oTpl->SetVar( "FormParams", "category_id=" . ToURL(GetParam("category_id")) . "&name=" . ToURL(GetParam("name")) . "&author=" . ToURL(GetParam("author")) . "&pricemin=" . ToURL(GetParam("pricemin")) . "&pricemax=" . ToURL(GetParam("pricemax")) . "&");
# Build WHERE statement

# Check author parameter and create a valid sql for where clause
  
  my $pauthor = GetParam("author");
  if ( $pauthor ne "" ) {
	$HasParam = 1;
    $sWhere = $sWhere . "i.author like '%" . replace($pauthor, "'", "''") . "%'"
  }
  
# Check category_id parameter and create a valid sql for where clause
  
  my $pcategory_id = GetParam("category_id");
  if ( $pcategory_id ne "" ) { $pcategory_id = int($pcategory_id) } else { $pcategory_id = "" }
  if ( $pcategory_id ne "" ) {
    if ( $sWhere ne "" ) { $sWhere = $sWhere . " and " }
	$HasParam = 1;
    $sWhere = $sWhere . "i.category_id=" . $pcategory_id
  }
  
# Check name parameter and create a valid sql for where clause
  
  my $pname = GetParam("name");
  if ( $pname ne "" ) {
    if ( $sWhere ne "" ) { $sWhere = $sWhere . " and " }
	$HasParam = 1;
    $sWhere = $sWhere . "i.name like '%" . replace($pname, "'", "''") . "%'"
  }
  
# Check pricemax parameter and create a valid sql for where clause
  
  my $ppricemax = GetParam("pricemax");
  if ( $ppricemax ne "" ) { $ppricemax = int($ppricemax) } else { $ppricemax = "" }
  if ( $ppricemax ne "" ) {
    if ( $sWhere ne "" ) { $sWhere = $sWhere . " and " }
	$HasParam = 1;
    $sWhere = $sWhere . "i.price<=" . $ppricemax
  }
  
# Check pricemin parameter and create a valid sql for where clause
  
  my $ppricemin = GetParam("pricemin");
  if ( $ppricemin ne "" ) { $ppricemin = int($ppricemin) } else { $ppricemin = "" }
  if ( $ppricemin ne "" ) {
    if ( $sWhere ne "" ) { $sWhere = $sWhere . " and " }
	$HasParam = 1;
    $sWhere = $sWhere . "i.price>=" . $ppricemin
  }
  
  if ( $HasParam ) { $sWhere = " WHERE (" . $sWhere . ")" }

  # Build full SQL statement
  
  my $sSQL = "select i.author as i_author, " . "i.category_id as i_category_id, " . "i.item_id as i_item_id, " . "i.name as i_name, " . "i.price as i_price " . " from items i ";

$sSQL="select count(item_id) as i_item_id from items as i";
  $sSQL = $sSQL . $sWhere . $sOrder;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListTotal", "" );
    $oTpl->Parse( "TotalNoRecords", "False" );
    $oTpl->Parse( "FormTotal", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $flditem_id = GetValue($ref_db_record, "i_item_id");

      $oTpl->SetVar( "item_id", ToHTML($flditem_id));

    $oTpl->Parse( "DListTotal", "True" );
    
  }


  $oTpl->SetVar( "TotalNoRecords", "" );
  $oTpl->Parse( "FormTotal", "False" );
  
}