#!\Perl\bin\perl.exe
#
# Filename: Default.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "Default.cgi";
my $sTemplateFileName = "Default.html";




$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



#Show form content

Menu_Show();
Footer_Show();
Search_Show();
AdvMenu_Show();
Recommended_Show();
What_Show();
Categories_Show();
New_Show();
Weekly_Show();
Specials_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub Search_Show {
  
  $oTpl->SetVar( "ActionPage", "Books.cgi" );

  # Set variables with search parameters
  
  my $fldcategory_id = GetParam("category_id");
  my $fldname = GetParam("name");
  # Show fields
  

      $oTpl->SetVar( "LBcategory_id", "" );
      $oTpl->SetVar( "ID", "" );
      $oTpl->SetVar( "Value", "All" );
      $oTpl->Parse( "LBcategory_id", "True" );
      my @category_id = openrs_arr( "select category_id, name from categories order by 2" );
      foreach my $category_id ( @category_id ) {
        $oTpl->SetVar( "ID", $category_id->[0] );
	$oTpl->SetVar( "Value", $category_id->[1] );
        if ( GetValue($category_id, 0) eq $fldcategory_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBcategory_id", "True" );
      }
        
      $oTpl->SetVar( "name", ToHTML($fldname));
  $oTpl->Parse( "FormSearch", "False" );
}


sub AdvMenu_Show {
  
  # Set URLs

  my $fldField1 = "AdvSearch.cgi";
  # Show fields

  $oTpl->SetVar( "Field1", $fldField1);  
  $oTpl->Parse( "FormAdvMenu", "False" );
  
}



sub Recommended_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );
# Build WHERE statement

  $sWhere = " WHERE is_recommended=1";
  
  # Build ORDER statement
  $iSort = GetParam("FormRecommended_Sorting");
  $iSorted = GetParam("FormRecommended_Sorted");
  $sDirection = "";
  if ( $iSort eq "" ) {
    $oTpl->SetVar( "Form_Sorting", "" );
  } else {
    if ( $iSort eq $iSorted ) { 
      $oTpl->SetVar( "Form_Sorting", "" );
      $sDirection = " DESC";
      $sSortParams = "FormRecommended_Sorting=" . $iSort . "&FormRecommended_Sorted=" . $iSort . "&";
    } else {
      $oTpl->SetVar( "Form_Sorting", $iSort );
      $sDirection = " ASC";
      $sSortParams = "FormRecommended_Sorting=" . $iSort . "&FormRecommended_Sorted=" . "&"
    }
    
    if ( $iSort == 1) { $sOrder = " order by i.name" . $sDirection }
    if ( $iSort == 2) { $sOrder = " order by i.author" . $sDirection }
    if ( $iSort == 3) { $sOrder = " order by i.image_url" . $sDirection }
    if ( $iSort == 4) { $sOrder = " order by i.price" . $sDirection }
  }

  # Build full SQL statement
  
  my $sSQL = "select i.author as i_author, " . "i.image_url as i_image_url, " . "i.item_id as i_item_id, " . "i.name as i_name, " . "i.price as i_price " . " from items i ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  $oTpl->SetVar( "SortParams", $sSortParams );
  
  # Select current page
  $iPage = GetParam("FormRecommended_Page");
  if ( $iPage eq "" ) { $iPage = 1 }
  $RecordsPerPage = 5;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListRecommended", "" );
    $oTpl->Parse( "RecommendedNoRecords", "False" );
    $oTpl->SetVar( "RecommendedScroller", "" );
    $oTpl->Parse( "FormRecommended", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldname = GetValue($ref_db_record, "i_name");
    my $fldauthor = GetValue($ref_db_record, "i_author");
    my $fldimage_url = GetValue($ref_db_record, "i_image_url");
    my $fldprice = GetValue($ref_db_record, "i_price");
$fldimage_url="<img border=0 src=" . $fldimage_url . ">";

      $oTpl->SetVar( "name", ToHTML($fldname) );
      $oTpl->SetVar( "name_URLLink", "BookDetail.cgi");
      $oTpl->SetVar( "Prm_item_id", ToURL(GetValue($ref_db_record, "i_item_id"))); 
      $oTpl->SetVar( "author", ToHTML($fldauthor));
      $oTpl->SetVar( "image_url", $fldimage_url);
      $oTpl->SetVar( "image_url_URLLink", "BookDetail.cgi");
      $oTpl->SetVar( "Prm_item_id", ToURL(GetValue($ref_db_record, "i_item_id"))); 
      $oTpl->SetVar( "price", ToHTML($fldprice));

    $oTpl->Parse( "DListRecommended", "True" );
    
  }


  # Parse scroller
  if ( $is_last_page and $iPage == 1 ) {
    $oTpl->SetVar( "RecommendedScroller", "" );
  } else {
    if ( $is_last_page ) {
      $oTpl->SetVar( "RecommendedScrollerNextSwitch", "_" );
    } else {
      $oTpl->SetVar( "NextPage", ($iPage + 1) );
      $oTpl->SetVar( "RecommendedScrollerNextSwitch", "" );
    }
    if ( $iPage == 1 ) {
      $oTpl->SetVar( "RecommendedScrollerPrevSwitch", "_" );
    } else {
      $oTpl->SetVar( "PrevPage", ($iPage - 1) );
      $oTpl->SetVar( "RecommendedScrollerPrevSwitch", "" );
    }
    $oTpl->SetVar( "RecommendedCurrentPage", $iPage );
    $oTpl->Parse( "RecommendedScroller", "False" );
  }

  $oTpl->SetVar( "RecommendedNoRecords", "" );
  $oTpl->Parse( "FormRecommended", "False" );
  
}



sub What_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );
# Build WHERE statement

  $sWhere = " AND editorial_cat_id=1";
  

  # Build full SQL statement
  
  my $sSQL = "select e.article_desc as e_article_desc, " . "e.article_title as e_article_title, " . "e.item_id as e_item_id, " . "i.item_id as i_item_id, " . "i.image_url as i_image_url " . " from editorials e, items as i" . " where i.item_id=e.item_id  ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListWhat", "" );
    $oTpl->Parse( "WhatNoRecords", "False" );
    $oTpl->Parse( "FormWhat", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldarticle_title = GetValue($ref_db_record, "e_article_title");
    my $fldarticle_desc = GetValue($ref_db_record, "e_article_desc");
    my $flditem_id = GetValue($ref_db_record, "i_image_url");
$flditem_id="<img border=0 src=" . $flditem_id . ">";

      $oTpl->SetVar( "article_title", ToHTML($fldarticle_title) );
      $oTpl->SetVar( "article_title_URLLink", "BookDetail.cgi");
      $oTpl->SetVar( "Prm_item_id", ToURL(GetValue($ref_db_record, "e_item_id"))); 
      $oTpl->SetVar( "article_desc", $fldarticle_desc);
      $oTpl->SetVar( "item_id", $flditem_id);
      $oTpl->SetVar( "item_id_URLLink", "BookDetail.cgi");
      $oTpl->SetVar( "Prm_item_id", ToURL(GetValue($ref_db_record, "e_item_id"))); 

    $oTpl->Parse( "DListWhat", "True" );
    
  }


  $oTpl->SetVar( "WhatNoRecords", "" );
  $oTpl->Parse( "FormWhat", "False" );
  
}



sub Categories_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );
# Build WHERE statement


  # Build full SQL statement
  
  my $sSQL = "select c.category_id as c_category_id, " . "c.name as c_name " . " from categories c ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListCategories", "" );
    $oTpl->Parse( "CategoriesNoRecords", "False" );
    $oTpl->Parse( "FormCategories", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldname = GetValue($ref_db_record, "c_name");

      $oTpl->SetVar( "name", ToHTML($fldname) );
      $oTpl->SetVar( "name_URLLink", "Books.cgi");
      $oTpl->SetVar( "Prm_category_id", ToURL(GetValue($ref_db_record, "c_category_id"))); 

    $oTpl->Parse( "DListCategories", "True" );
    
  }


  $oTpl->SetVar( "CategoriesNoRecords", "" );
  $oTpl->Parse( "FormCategories", "False" );
  
}



sub New_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );
# Build WHERE statement

  $sWhere = " AND editorial_cat_id=2";
  

  # Build full SQL statement
  
  my $sSQL = "select e.article_desc as e_article_desc, " . "e.article_title as e_article_title, " . "e.item_id as e_item_id, " . "i.item_id as i_item_id, " . "i.image_url as i_image_url " . " from editorials e, items as i" . " where i.item_id=e.item_id  ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListNew", "" );
    $oTpl->Parse( "NewNoRecords", "False" );
    $oTpl->Parse( "FormNew", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldarticle_title = GetValue($ref_db_record, "e_article_title");
    my $flditem_id = GetValue($ref_db_record, "i_image_url");
    my $fldarticle_desc = GetValue($ref_db_record, "e_article_desc");
$flditem_id="<img border=0 src=" . $flditem_id . ">";

      $oTpl->SetVar( "article_title", ToHTML($fldarticle_title) );
      $oTpl->SetVar( "article_title_URLLink", "BookDetail.cgi");
      $oTpl->SetVar( "Prm_item_id", ToURL(GetValue($ref_db_record, "e_item_id"))); 
      $oTpl->SetVar( "item_id", $flditem_id);
      $oTpl->SetVar( "item_id_URLLink", "BookDetail.cgi");
      $oTpl->SetVar( "Prm_item_id", ToURL(GetValue($ref_db_record, "e_item_id"))); 
      $oTpl->SetVar( "article_desc", ToHTML($fldarticle_desc));

    $oTpl->Parse( "DListNew", "True" );
    
  }


  $oTpl->SetVar( "NewNoRecords", "" );
  $oTpl->Parse( "FormNew", "False" );
  
}



sub Weekly_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );
# Build WHERE statement

  $sWhere = " AND editorial_cat_id=3";
  

  # Build full SQL statement
  
  my $sSQL = "select e.article_desc as e_article_desc, " . "e.article_title as e_article_title, " . "e.item_id as e_item_id, " . "i.item_id as i_item_id, " . "i.image_url as i_image_url " . " from editorials e, items as i" . " where i.item_id=e.item_id  ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListWeekly", "" );
    $oTpl->Parse( "WeeklyNoRecords", "False" );
    $oTpl->Parse( "FormWeekly", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldarticle_title = GetValue($ref_db_record, "e_article_title");
    my $flditem_id = GetValue($ref_db_record, "i_image_url");
    my $fldarticle_desc = GetValue($ref_db_record, "e_article_desc");
$flditem_id="<img border=0 src=" . $flditem_id . ">";

      $oTpl->SetVar( "article_title", ToHTML($fldarticle_title) );
      $oTpl->SetVar( "article_title_URLLink", "BookDetail.cgi");
      $oTpl->SetVar( "Prm_item_id", ToURL(GetValue($ref_db_record, "e_item_id"))); 
      $oTpl->SetVar( "item_id", $flditem_id);
      $oTpl->SetVar( "item_id_URLLink", "BookDetail.cgi");
      $oTpl->SetVar( "Prm_item_id", ToURL(GetValue($ref_db_record, "e_item_id"))); 
      $oTpl->SetVar( "article_desc", ToHTML($fldarticle_desc));

    $oTpl->Parse( "DListWeekly", "True" );
    
  }


  $oTpl->SetVar( "WeeklyNoRecords", "" );
  $oTpl->Parse( "FormWeekly", "False" );
  
}



sub Specials_Show {

  my ( $sOrder, $iSort, $iSorted, $sDirection, $sSortParams, $iPage );
  my $sWhere = "";
  my $HasParam = 0;
  my $sOrder = "";
  my $sSQL = "";



  $oTpl->SetVar( "TransitParams", "" );
  $oTpl->SetVar( "FormParams", "" );
# Build WHERE statement

  $sWhere = " WHERE editorial_cat_id=4";
  

  # Build full SQL statement
  
  my $sSQL = "select e.article_desc as e_article_desc, " . "e.article_title as e_article_title " . " from editorials e ";

  $sSQL = $sSQL . $sWhere . $sOrder;
  # Open recordset
  my @db_rs = openrs( $sSQL, $iPage ); 
  if ( $#db_rs == -1 ) { 
  # Recordset is empty
    $oTpl->SetVar( "DListSpecials", "" );
    $oTpl->Parse( "SpecialsNoRecords", "False" );
    $oTpl->Parse( "FormSpecials", "False" );
    return 0
  }



  # Show main table based on recordset
  foreach my $ref_db_record ( @db_rs ) {
    
    my $fldarticle_title = GetValue($ref_db_record, "e_article_title");
    my $fldarticle_desc = GetValue($ref_db_record, "e_article_desc");

      $oTpl->SetVar( "article_title", $fldarticle_title);
      $oTpl->SetVar( "article_desc", $fldarticle_desc);

    $oTpl->Parse( "DListSpecials", "True" );
    
  }


  $oTpl->SetVar( "SpecialsNoRecords", "" );
  $oTpl->Parse( "FormSpecials", "False" );
  
}