#!\Perl\bin\perl.exe
#
# Filename: OrdersRecord.cgi
# Generated with CodeCharge  1.1.20
# Perl pattern build 05/23/2001
#

use Common;
use TextTemplate;
use strict "vars";

use Header;
use Footer;

StartSession();
%cgi_params = get_form_parameters();

my $sFileName = "OrdersRecord.cgi";
my $sTemplateFileName = "OrdersRecord.html";



CheckSecurity(2);


my $sOrdersErr;
$dbh = DBI->connect( $strConn, $username, $password, { PrintError => 0, RaiseError => 0 } );


$oTpl->LoadTemplate( $sAppPath . $sTemplateFileName, "main" );

$oTpl->LoadTemplate( $sHeaderFileName, "Header" );
$oTpl->LoadTemplate( $sFooterFileName, "Footer" );
$oTpl->SetVar( "FileName", $sFileName );



my $sAction = GetParam("FormAction");
my $sForm = GetParam("FormName");


  if ( $sForm eq "Orders" ) {
    OrdersAction( $sAction ) }

#Show form content

Menu_Show();
Footer_Show();
Orders_Show();
$oTpl->Parse( "Header", "False" );
$oTpl->Parse( "Footer", "False" );
$oTpl->Parse( "main", "False" );

print $page_header;
print "Content-type: text/html\n\n";
print $oTpl->PrintVar("main");

exit 0;




sub OrdersAction {
  my $sAction = shift;

  my $sParams = "";
  my $sWhere = "";
  my $bErr = "";
  my $sSQL = "";
  my $sRes = "";

  
  my $sActionFileName = "OrdersGrid.cgi";
  
  $sParams = "?";
  $sParams = $sParams . "item_id=" . ToURL(GetParam("Trn_item_id")) . "&";
  $sParams = $sParams . "member_id=" . ToURL(GetParam("Trn_member_id"));
  if ( $sAction eq "cancel" ) { http_redirect( $sActionFileName . $sParams  ) }
  # Create WHERE statement
  if ( $sAction eq "update" or $sAction eq "delete" ) {
    my $pPKorder_id = GetParam("PK_order_id");
    if ( ($pPKorder_id eq "")) { return 0; }
    $sWhere = "order_id=" . ToSQL($pPKorder_id, "Number");
  }

  # Load all form fields into variables

  my $fldmember_id = GetParam("member_id");
  my $flditem_id = GetParam("item_id");
  my $fldquantity = GetParam("quantity");
  # Validate fields
  if ( $sAction eq "insert" or $sAction eq "update" ) {
    if ( $fldmember_id eq "" ) {
      $sOrdersErr = $sOrdersErr . "The value in field Member is required.<br>"
    }
    if ( $flditem_id eq "" ) {
      $sOrdersErr = $sOrdersErr . "The value in field Item is required.<br>"
    }
    if ( $fldquantity eq "" ) {
      $sOrdersErr = $sOrdersErr . "The value in field Quantity is required.<br>"
    }
    if ( !IsNumeric($fldmember_id) ) {
      $sOrdersErr = $sOrdersErr . "The value in field Member is incorrect.<br>"
    }
    if ( !IsNumeric($flditem_id) ) {
      $sOrdersErr = $sOrdersErr . "The value in field Item is incorrect.<br>"
    }
    if ( !IsNumeric($fldquantity) ) {
      $sOrdersErr = $sOrdersErr . "The value in field Quantity is incorrect.<br>"
    }
    if ( length($sOrdersErr) > 0 ) {
      return 0;
    }
  }


# Create SQL statement

    if ( $sAction eq "insert" ) {      
      
      $sSQL = "insert into orders (" . 
          "member_id," . 
          "item_id," . 
          "quantity)" . 
          " values (" . 
          ToSQL($fldmember_id, "Number") . "," . 
          ToSQL($flditem_id, "Number") . "," . 
          ToSQL($fldquantity, "Number") . ")"
}
      
    if ( $sAction eq "update" ) {
        $sSQL = "update orders set " .
        "member_id=" . ToSQL($fldmember_id, "Number") .
        ",item_id=" . ToSQL($flditem_id, "Number") .
        ",quantity=" . ToSQL($fldquantity, "Number");
        $sSQL = $sSQL . " where " . $sWhere
    }
    
    if ( $sAction eq "delete" ) {
        $sSQL = "delete from orders where " . $sWhere
    }
    
  if ( length($sOrdersErr) > 0 ) { return 0 }
  # Execute SQL statement
  exec_sql($sSQL);
  $sOrdersErr = ProceedError();
  if ( length( $sOrdersErr ) > 0 ) { return 0 }

  http_redirect( $sActionFileName . $sParams );
  
}


sub Orders_Show {
  my $porder_id;

  my $porder_id;
  my $sWhere = "";
  
  my $bPK = "True";
  my $fldorder_id;
  my $fldmember_id;
  my $flditem_id;
  my $fldquantity;
  my $flditem_id;
  my $fldmember_id;
  my $fldorder_id;
  my $porder_id;

  my $sOrder;

  if ( $sOrdersErr eq "" ) {
    # Load primary key and form parameters
    $flditem_id = GetParam("item_id");
    $fldmember_id = GetParam("member_id");
    $fldorder_id = GetParam("order_id");
    $oTpl->SetVar( "Trn_item_id", GetParam("item_id") );
    $oTpl->SetVar( "Trn_member_id", GetParam("member_id") );
    $porder_id = GetParam("order_id");
    $oTpl->SetVar( "OrdersError", "" );
  } else {
    # Load primary key, form parameters and form fields
    $fldmember_id = GetParam("member_id");
    $flditem_id = GetParam("item_id");
    $fldquantity = GetParam("quantity");
    $oTpl->SetVar( "Trn_item_id", GetParam("Trn_item_id") );
    $oTpl->SetVar( "Trn_member_id", GetParam("Trn_member_id") );
    $porder_id = GetParam("PK_order_id");
    $oTpl->SetVar( "sOrdersErr", $sOrdersErr );
    $oTpl->Parse( "OrdersError", "False" );
  }

  
  if ( ($porder_id eq "")) { $bPK = ""; }
    
  $sWhere = $sWhere . "order_id=" . ToSQL($porder_id, "Number");
  $oTpl->SetVar( "PK_order_id", $porder_id );

  my $sSQL = "select * from orders where " . $sWhere;
  my $ref_db_record;


  if ( $bPK and !($sAction eq "insert" and $sForm eq "Orders") ) {
      # Open recordset
      my @db_rs = openrs($sSQL);
      $ref_db_record = $db_rs[0];
    
    $fldorder_id = GetValue($ref_db_record, "order_id");
    if ( $sOrdersErr eq "" ) {
      # Load data from recordset when form displayed first time
      $fldmember_id = GetValue($ref_db_record, "member_id");
      $flditem_id = GetValue($ref_db_record, "item_id");
      $fldquantity = GetValue($ref_db_record, "quantity");
    }
    $oTpl->SetVar( "OrdersInsert", "" );
    $oTpl->Parse( "OrdersEdit", "False" );
  } else {
    if ( $sOrdersErr eq "" ) {
      $fldorder_id = ToHTML(GetParam("order_id"));
      $fldmember_id = ToHTML(GetParam("member_id"));
      $flditem_id = ToHTML(GetParam("item_id"));
    }
    $oTpl->SetVar( "OrdersEdit", "" );
    $oTpl->Parse( "OrdersInsert", "False" );
  }
  $oTpl->Parse( "OrdersCancel", "False" );
  # Show form field
  
      $oTpl->SetVar( "order_id", ToHTML($fldorder_id));
      $oTpl->SetVar( "LBmember_id", "" );
      my @member_id = openrs_arr( "select member_id, member_login from members order by 2" );
      foreach my $member_id ( @member_id ) {
        $oTpl->SetVar( "ID", $member_id->[0] );
	$oTpl->SetVar( "Value", $member_id->[1] );
        if ( GetValue($member_id, 0) eq $fldmember_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBmember_id", "True" );
      }
        
      $oTpl->SetVar( "LBitem_id", "" );
      my @item_id = openrs_arr( "select item_id, name from items order by 2" );
      foreach my $item_id ( @item_id ) {
        $oTpl->SetVar( "ID", $item_id->[0] );
	$oTpl->SetVar( "Value", $item_id->[1] );
        if ( GetValue($item_id, 0) eq $flditem_id) { $oTpl->SetVar( "Selected", "SELECTED" ) } else { $oTpl->SetVar( "Selected", "" ) }
        $oTpl->Parse( "LBitem_id", "True" );
      }
        
      $oTpl->SetVar( "quantity", ToHTML($fldquantity));
  $oTpl->Parse( "FormOrders", "False" );
  

}